<template>
  <div class="bbsl-common-page">
    <div class="bbsl-table-search">
      <el-form v-model="queryParam" label-width="auto">
        <el-row :gutter="5">
          <el-col :span="5">
            <el-form-item label="产生方式">
              <el-select v-model="querys[0].value" style="width:100%" clearable>
                <el-option v-for="item in produceTypeList" :key="item.value" :label="item.name" :value="item.value" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="5">
            <el-form-item label="提醒方式">
              <el-select v-model="querys[1].value" style="width:100%" clearable>
                <el-option v-for="item in remindTypeList" :key="item.value" :label="item.name" :value="item.value" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="5">
            <el-form-item label="发送状态">
              <el-select v-model="querys[2].value" style="width:100%" clearable>
                <el-option v-for="item in sendStatusList" :key="item.value" :label="item.name" :value="item.value" />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="5">
            <el-form-item label="工作提醒标题">
              <el-input v-model="querys[3].value" clearable placeholder="请输入工作提醒标题" />
            </el-form-item>
          </el-col>
          <el-col :span="4">
            <el-button type="primary" icon="el-icon-search" @click="handleSearch">搜索</el-button>
            <el-button icon="el-icon-refresh" @click="handleReset">重置</el-button>
          </el-col>
        </el-row>
      </el-form>
    </div>
    <div ref="contentPanel" class="bbsl-table-content">
      <!-- <div ref="btnPanel" class="bbsl-btn-content">
        <el-button icon="el-icon-plus" type="primary" @click="handleAdd"
          >新增</el-button
        >
        <el-popconfirm title="确定删除选中数据吗？" @confirm="handleDelete">
          <el-button
            slot="reference"
            :disabled="!multipleSelection.length"
            icon="el-icon-delete"
            type="danger"
            style="margin-left: 10px"
            >删除</el-button
          >
        </el-popconfirm>
      </div> -->
      <el-table ref="multipleSelection" v-loading="loading" border size="mini" :data="tableData"
        :style="{ width: '100%' }" :max-height="tableMaxHeight" :cell-style="{ 'text-align': 'center' }"
        :header-cell-style="{ 'text-align': 'center' }" @row-dblclick="handleDbClick"
        @selection-change="handleSelectionChange">
        <!-- <el-table-column type="selection" width="55" /> -->
        <el-table-column fixed type="index" width="55" label="序号" />
        <el-table-column prop="produceType" label="产生方式" show-overflow-tooltip />
        <el-table-column prop="remindType" label="提醒方式" show-overflow-tooltip />
        <el-table-column prop="remindRange" label="通知范围" show-overflow-tooltip />
        <el-table-column prop="workRemindTitle" label="工作提醒标题" show-overflow-tooltip />
        <el-table-column prop="msgExigency" width="110" label="消息紧急程度" show-overflow-tooltip>
          <template slot-scope="scope">
            <el-tag v-if="scope.row.msgExigency === '1'" type="success">普通</el-tag>
            <el-tag v-else-if="scope.row.msgExigency === '2'" type="warning">一般较急</el-tag>
            <el-tag v-else-if="scope.row.msgExigency === '3'" type="danger">紧急</el-tag>
          </template></el-table-column>
        <el-table-column prop="sendTime" width="155" label="发送时间" show-overflow-tooltip />
        <el-table-column prop="sendStatus" width="100" label="发送状态" show-overflow-tooltip />
        <el-table-column prop="sendPersons" width="100" label="通知人数" show-overflow-tooltip />
        <el-table-column prop="receivePersons" width="100" label="已接收人数" show-overflow-tooltip />
        <el-table-column align="right" width="100" label="操作" :index="999">
          <template slot-scope="scope">
            <el-button size="mini" type="primary" plain @click="detail(scope.row)">详情</el-button>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination ref="paginationPanel" align="right" background class="bbsl-pagination"
        :current-page="queryParam.pageBean.page" :page-sizes="[20, 30, 40, 50]"
        :page-size="queryParam.pageBean.pageSize" layout="total, sizes, prev, pager, next, jumper" :total="total"
        @size-change="handleSizeChange" @current-change="handleCurrentChange" />
    </div>
    <el-dialog width="78%" title="当月申请单" :visible.sync="dialogVisible">
      <el-table border class="application" size="mini" :cell-style="{ 'text-align': 'center' }"
        :header-cell-style="{ 'text-align': 'center' }" :data="gridData">
        <el-table-column fixed type="index" width="55" label="序号" />
        <el-table-column prop="produceType" label="产生方式" show-overflow-tooltip />
        <el-table-column prop="remindType" label="提醒方式" show-overflow-tooltip />
        <!-- <el-table-column
          
          prop="remindRange"
          label="通知范围"
          show-overflow-tooltip
        /> -->
        <el-table-column prop="workRemindTitle" label="工作提醒标题" show-overflow-tooltip />
        <el-table-column prop="workRemindContent" label="工作提醒通知内容" show-overflow-tooltip width="180" />
        <el-table-column prop="msgExigency" label="消息紧急程度" show-overflow-tooltip>
          <template slot-scope="scope">
            <el-tag v-if="scope.row.msgExigency === '1'" type="success">普通</el-tag>
            <el-tag v-else-if="scope.row.msgExigency === '2'" type="warning">一般较急</el-tag>
            <el-tag v-else-if="scope.row.msgExigency === '3'" type="danger">紧急</el-tag>
          </template></el-table-column>
        <el-table-column prop="sendTime" width="160" label="发送时间" show-overflow-tooltip />
        <el-table-column prop="receiveStatus" label="发送状态" show-overflow-tooltip />
      </el-table>
    </el-dialog>
    <!-- <CmgtTSaftyWorkSendFormDialog ref="formModal" /> -->
  </div>
</template>

<script>
import { TableMixin } from '@/mixins/tableMixin'
import dictUtils from '@/components/dict/DictSelectUtils.js'
import dictContracts from '@/components/dict/DictSelectUtils.js'

import CmgtTSaftyWorkConfApi from '@/views/Manage/saftyDanger/api/CmgtTSaftyWorkConfApi'
import CmgtTSaftyWorkSendFormDialog from '@/views/Manage/saftyDanger/components/CmgtTSaftyWorkSendFormDialog'

export default {
  name: 'CmgtSaftyDangerUnitManage',
  components: {
    CmgtTSaftyWorkSendFormDialog
  },
  mixins: [TableMixin],
  data() {
    return {
      dialogVisible: false,
      gridData: [],
      url: {
        delete: '/manager/cmgtSaftyDangerUnit/delete'
      },
      querys: [
        {
          group: 'main',
          operation: 'EQUAL',
          parentGroup: '',
          property: 'produceType',
          relation: 'AND',
          value: ''
        },
        {
          group: 'main',
          operation: 'EQUAL',
          parentGroup: '',
          property: 'remindType',
          relation: 'AND',
          value: ''
        },
        {
          group: 'main',
          operation: 'EQUAL',
          parentGroup: '',
          property: 'sendStatus',
          relation: 'AND',
          value: ''
        },
        {
          group: 'main',
          operation: 'LIKE',
          parentGroup: '',
          property: 'workRemindTitle',
          relation: 'AND',
          value: ''
        }
      ],
      StshowFormDias: false,
      sorter: [
        {
          direction: 'ASC',
          property: 'sendTime'
        }
      ]
      // levels:[]
    }
  },
  created() {
    this.produceTypeList = dictUtils.getDictItemsFromCache('yjcsfs')
    this.sendStatusList = dictUtils.getDictItemsFromCache('yjxxfszt')
    this.remindTypeList = dictUtils.getDictItemsFromCache('yjtxfs')
    this.remindRangeList = dictUtils.getDictItemsFromCache('tzfw')
    console.log(this.produceTypeList)
  },
  mounted() { },
  methods: {
    //
    ActivateDisable() { },
    // 重置
    clearQuerys() {
      this.querys[0].value = ''
      this.querys[1].value = ''
      this.querys[2].value = ''
      this.querys[3].value = ''
    },
    // 获取list
    loadData(page) {
      if (page) {
        this.queryParam.pageBean.page = page
      }
      this.loading = true
      this.tableData = []
      this.queryParam.querys = []
      this.queryParam.sorter = this.sorter
      if (this.querys[0].value) {
        this.queryParam.querys.push(this.querys[0])
      }
      if (this.querys[1].value) {
        this.queryParam.querys.push(this.querys[1])
      }
      if (this.querys[2].value) {
        this.queryParam.querys.push(this.querys[2])
      }
      if (this.querys[3].value) {
        this.queryParam.querys.push(this.querys[3])
      }
      CmgtTSaftyWorkConfApi.cmgtWorkWarnSendQuery(this.queryParam, res => {
        console.log(res)
        this.total = res.total
        this.tableData = res.rows
        this.tableData.forEach(item => {
          console.log(item)
          this.produceTypeList.forEach(val => {
            console.log(val)
            if (item.produceType == val.value) {
              item.produceType = val.name
            }
          })
          this.sendStatusList.forEach(val => {
            if (item.sendStatus == val.value) {
              item.sendStatus = val.name
            }
          })
          this.remindTypeList.forEach(val => {
            if (item.remindType == val.value) {
              item.remindType = val.name
            }
          })
          this.remindRangeList.forEach(val => {
            if (item.remindRange == val.value) {
              item.remindRange = val.name
            }
          })
        })
        this.$set(this.tableData)
        this.loading = false
      })
    },
    handleDelete() {
      //   console.log(this.multipleSelection)
      CmgtTSaftyWorkConfApi.deleteCmgtSaftyDangerUnit(this.multipleSelection)
        .then(res => {
          if (res.state) {
            this.$notify({
              type: 'success',
              message: '删除成功',
              duration: 2000
            })
            this.queryParam.pageBean.page = 1
            this.loadData()
          }
        })
        .catch(res => {
          this.$notify({
            type: 'error',
            message: res.message,
            duration: 2000,
            offset: 80
          })
        })
    },
    // 详情
    detail(row) {
      console.log(row)
      this.gridData = row.detail
      this.gridData.forEach(item => {
        // console.log(item)
        this.produceTypeList.forEach(val => {
          // console.log(val)
          if (item.produceType == val.value) {
            item.produceType = val.name
          }
        })
        this.sendStatusList.forEach(val => {
          if (item.receiveStatus == val.value) {
            item.receiveStatus = val.name
          }
        })
        this.remindTypeList.forEach(val => {
          if (item.remindType == val.value) {
            item.remindType = val.name
          }
        })
        this.remindRangeList.forEach(val => {
          if (item.remindRange == val.value) {
            item.remindRange = val.name
          }
        })
      })
      this.dialogVisible = true
    },
    closeStshowForm() {
      this.StshowFormDias = false
    },
    formartTyepName(row, column, cellValue, index) {
      var obj = this.types.find(function (item) {
        if (item.value === row.type) {
          //
          return item
        }
      })
      if (obj !== undefined) {
        return obj.name
      } else {
        return ''
      }
    }
  }
}
</script>
<style lang="scss" scoped>
.type-tag {
  margin: 0 2px;
}
</style>
